#INCLUDE 'MINIGUI.CH'
#INCLUDE 'ADODB.CH'
#INCLUDE 'i_usrInit.ch'
#include 'i_usrsoop.ch'

PROCEDURE Main
	LOCAL i := 1
	PUBLIC oConexion, oTabla	

	SET DATE BRITISH
	SET CENTURY ON
	
	IniciarConexion()
		
	DEFINE WINDOW Form1 AT 0,0 WIDTH ((Getdesktopwidth()/5)*3) HEIGHT ((Getdesktopheight()/5)*4) TITLE 'Test BrowseAdo' MAIN ;
			ON INIT ( Ajustar(), Form1.Browse_1.Position := 1 );
			ON SIZE ( Ajustar() );
			ON RELEASE CerrarConexion()

		DEFINE MAIN MENU			
			POPUP 'File'
				MENUITEM 'Enable'	ACTION FORM1.BROWSE_1.ENABLE
				MENUITEM 'Disable'	ACTION FORM1.BROWSE_1.DISABLE
				MENUITEM 'Refresh'  ACTION FORM1.BROWSE_1.REFRESH
				MENUITEM 'Set Position' ACTION PUTPOSITION(oTabla)
				MENUITEM 'SetFocus' ACTION form1.browse_1.setfocus
				MENUITEM 'Lock edition' ACTION form1.browse_1.lock := .t.
				MENUITEM 'UnLock edition' ACTION form1.browse_1.lock := .f.
				MENUITEM 'SET FONT' ACTION SETPROPERTY('FORM1', 'BROWSE_1', 'FONTNAME', 'TIMES NEW ROMAN')
				MENUITEM 'SET FONT SIZE' ACTION SETPROPERTY('FORM1', 'BROWSE_1', 'FONTSIZE', 10)
				MENUITEM 'CHANGE BACKCOLOR' ACTION form1.browse_1.backcolor:= { 127,127,127 } 
				MENUITEM 'NOLINES' ACTION MSGINFO('SUPPORT')
				MENUITEM 'SET DELETE' 		ACTION form1.browse_1.delete := .T.
				MENUITEM 'SET NOT DELETE' 	ACTION form1.browse_1.delete := .F.
				MENUITEM 'GET DELETE' ACTION MSGINFO( 'BROWSE DELETE '+IF(FORM1.BROWSE_1.DELETE,'.T.','.F.'))
				MENUITEM 'SHOW' ACTION FORM1.BROWSE_1.VISIBLE := .T.
				MENUITEM 'HIDE' ACTION FORM1.BROWSE_1.VISIBLE := .F.
				SEPARATOR
				MENUITEM '&Exit' ACTION Form1.release				
			END POPUP
			POPUP 'Help'
				MENUITEM 'Help' ACTION Ayuda()
			END POPUP
		END MENU
				
		DEFINE BROWSEADO BROWSE_1
			ROW 			0
			COL 			0
			WIDTH 			300
			HEIGHT 			270
			HEADERS			{'Id','First','Last','Birthday','Married'}
			FIELDS			{'Id','First','Last','Birth','Married'}
			READONLYFIELDS 	{.T., .F., .F., .F., .F. }
			VALID			{ { || .F.}, { || IF( EMPTY(Memvar.first), .F., .T. ) }, { || IF( EMPTY(Memvar.Last ), .F., .T. ) }, { || .T. }, { || .T. }}
			INPUTMASK		{'999,999',NIL,NIL,NIL,NIL}
			POSITION		1			
			RECORDSET 		oTabla
			WIDTHS			{ 80, 150, 150, 100, 100 }
			LOCK		.F.
			ON CHANGE		Form1.Statusbar.item(1) := "Registro : "+HB_VALTOSTR(oTabla:Fields(0):Value)
			ON HEADCLICK	{ { || Ordenar(1) }, { || Ordenar(2) }, { || Ordenar(3) } }
			NOLINES			.T.
			BACKCOLOR		{ 247, 247, 247 }
		END BROWSEADO
		
		DEFINE STATUSBAR
			STATUSITEM ''
			DATE
			CLOCK
		END STATUSBAR

	END WINDOW
	Form1.Center
	ACTIVATE WINDOW Form1
		
RETURN
	
PROCEDURE PUTPOSITION(oTabla)
	LOCAL cValue := INPUTBOX('Position','Input new position', cValue)
	IF LEN( cValue ) > 0
		IF VALTYPE( VAL(cValue) ) = 'N'
			IF VAL(cValue)>0 .and. VAL(cVAlue) < oTabla:Recordcount
				form1.browse_1.Position := val(cvalue)
				FORM1.BROWSE_1.REFRESH
				form1.browse_1.setfocus
			ENDIF
		ENDIF
	ENDIF
RETURN

STATIC PROCEDURE ajustar
	form1.Browse_1.Width	:= Form1.Width - 10
	form1.browse_1.Height	:= Form1.Height - 90
RETURN

STATIC PROCEDURE IniciarConexion
	oConexion = TOleauto():New('ADODB.Connection')
	oConexion:ConnectionString ='Provider=Microsoft.Jet.OLEDB.4.0;'+;
								'Data Source=test.mdb;'+;
								'User Id=Admin;'+;
								"Password=;"
	oConexion:Open()

	oTabla 					:= TOleAuto():New('ADODB.Recordset')
	oTabla:CursorLocation 	:= adUseClient
	oTabla:Open( "SELECT * FROM Test", oConexion, adOpenDynamic, adLockOptimistic )
	IF oTabla:State = adStateClose
		Msgstop('No se pudo ejecutar la instruccion'+hb_osnewline()+cSql,'Error de apertura')
		oConexion:close()
		QUIT
	ENDIF
RETURN

STATIC PROCEDURE CerrarConexion
	oTabla:close()
	oConexion:Close()
RETURN

STATIC PROCEDURE Ordenar(n)
	DO CASE
	CASE n = 1
		oTabla:Sort='Id'
	CASE n = 2
		oTabla:Sort='First'
	CASE n = 3
		oTabla:Sort='Last'
	ENDCASE
	oTabla:Requery()
	oTabla:MoveFirst()
	FORM1.BROWSE_1.POSITION	:= oTabla:AbsolutePosition
	FORM1.BROWSE_1.REFRESH
RETURN

PROCEDURE AYUDA
	
RETURN