/*
*
* Constantes para usar con conexion a Adodb
*
*/
#xcommand TRY              => bError := errorBlock( {|oErr| break( oErr ) } ) ;;
                                 BEGIN SEQUENCE
#xcommand CATCH [<!oErr!>] => errorBlock( bError ) ;;
                                RECOVER [USING <oErr>] <-oErr-> ;;
                                errorBlock( bError )
#DEFINE LEFT 0
#DEFINE RIGHT 1
#DEFINE CENTER 2

/********************************************************************************
TIPOS DE CURSOR Uso : oRs:Open(SQL_COMMAND, oConexion, Tipo_Cursor, Tipo_Cerrojo)
*********************************************************************************/
#DEFINE adOpenForwardOnly 	0
#DEFINE adOpenKeySet 		1
#DEFINE adOpenDynamic 		2
#DEFINE adOpenStatic 		3


*---- ObjectStateEnum Values ----
#DEFINE adStateClose	 	0x00000000
#DEFINE adStateOpen	 		0x00000001
#DEFINE adStateConnecting	0x00000002
#DEFINE adStateExecuting	0x00000004

/**************************************************** 	
TIPO DE CERROJO : Uso : oRs:LockType = adLockReadOnly
*****************************************************/

#DEFINE adLockReadOnly 		1
#DEFINE adLockPessimistic 	2
#DEFINE adLockOptimistic 	3
#DEFINE adBatchOptimistic 	4

#DEFINE adAffectCurrent 	0
#DEFINE adAffectGroup 		1

#DEFINE adUseClient 		3
#DEFINE adUseServer 		2


*---- CursorOptionEnum Values ----
#DEFINE adHoldRecords	 		0x00000100
#DEFINE admovePrevious	 		0x00000200
#DEFINE adAddNew	 			0x01000400
#DEFINE adDelete	 	     	0x01000800
#DEFINE adUpdate	 	     	0x01008000
#DEFINE adBookmark	 	   		0x00002000
#DEFINE adApproxposition		0x00004000
#DEFINE adUpdateBatch	 		0x00010000
#DEFINE adResync	 			0x00020000
#DEFINE adNotify	 			0x00040000	

*---- ExecuteOptionEnum Values ----
#DEFINE ADASYNCEXECUTE	 		0x00000010
#DEFINE ADASYNCFETCH	 		0x00000020
#DEFINE ADASYNCFETCHNONBLOCKING	0x00000040
#DEFINE ADEXECUTENORECORDS	 	0x00000080

*---- FieldAttributeEnum Values ----
#DEFINE ADFLDMAYDEFER	 		0x00000002
#DEFINE ADFLDUPDATABLE	 		0x00000004
#DEFINE ADFLDUNKNOWNUPDATABLE	0x00000008
#DEFINE ADFLDFIXED	 			0x00000010
#DEFINE ADFLDISNULLABLE	 		0x00000020
#DEFINE ADFLDMAYBENULL	 		0x00000040
#DEFINE ADFLDLONG	 			0x00000080
#DEFINE ADFLDROWID	 			0x00000100
#DEFINE ADFLDROWVERSION	 		0x00000200
#DEFINE ADFLDCACHEDEFERRED	 	0x00001000

*---- EditModeEnum Values ----
#DEFINE ADEDITNONE	 			0x0000
#DEFINE ADEDITINPROGRESS	 	0x0001
#DEFINE ADEDITADD	 			0x0002
#DEFINE ADEDITDELETE	 		0x0004

*---- RecordStatusEnum Values ----
#DEFINE ADRECOK	 				0x0000000
#DEFINE ADRECNEW				0x0000001
#DEFINE ADRECMODIFIED			0x0000002
#DEFINE ADRECDELETED			0x0000004
#DEFINE ADRECUNMODIFIED			0x0000008
#DEFINE ADRECINVALID			0x0000010
#DEFINE ADRECMULTIPLECHANGES	0x0000040
#DEFINE ADRECPENDINGCHANGES		0x0000080
#DEFINE ADRECCANCELED	 		0x0000100
#DEFINE ADRECCANTRELEASE	 	0x0000400
#DEFINE ADRECCONCURRENCYVIOLATION	0x0000800
#DEFINE ADRECINTEGRITYVIOLATION	0x0001000
#DEFINE ADRECMAXCHANGESEXCEEDED	0x0002000
#DEFINE ADRECOBJECTOPEN	 		0x0004000
#DEFINE ADRECOUTOFMEMORY		0x0008000
#DEFINE ADRECPERMISSIONDENIED	0x0010000
#DEFINE ADRECSCHEMAVIOLATION	0x0020000
#DEFINE ADRECDBDELETED	 		0x0040000

*---- GetRowsOptionEnum Values ----
#DEFINE ADGETROWSREST	 -1

*---- PositionEnum Values ----
#DEFINE ADPOSUNKNOWN	-1
#DEFINE ADPOSBOF	 -2
#DEFINE ADPOSEOF	 -3

*---- BookmarkConstants Values ----
#DEFINE ADBOOKMARKCURRENT	0.0
#DEFINE ADBOOKMARKFIRST	 1.0
#DEFINE ADBOOKMARKLAST	 2.0

*---- MarshalOptionsEnum Values ----
#DEFINE ADMARSHALALL	 0
#DEFINE ADMARSHALMODIFIEDONLY	1

*---- AffectEnum Values ----
#DEFINE ADAFFECTCURRENT	 1
#DEFINE ADAFFECTGROUP	 2
#DEFINE ADAFFECTALL	 3

*---- FilterGroupEnum Values ----
#DEFINE ADFILTERNONE	 0
#DEFINE ADFILTERPENDINGRECORDS	 1
#DEFINE ADFILTERAFFECTEDRECORDS	 2
#DEFINE ADFILTERFETCHEDRECORDS	 3
#DEFINE ADFILTERPREDICATE	 4

*---- SearchDirectionEnum Values ----
#DEFINE ADSEARCHFORWARD	 1
#DEFINE ADSEARCHBACKWARD	-1

*---- PersistFormatEnum Values ----
#DEFINE ADPERSISTADTG	 0
#DEFINE ADPERSISTXML	 1
#DEFINE ADPERSISTHTML	 2

*---- SaveOptionEnum Values ----
#DEFINE ADSAVEOVERWRITE	 0
#DEFINE ADSAVEFAILIFEXIST	

*---- ConnectPromptEnum Values ----
#DEFINE ADPROMPTALWAYS	 1
#DEFINE ADPROMPTCOMPLETE	 2
#DEFINE ADPROMPTCOMPLETEREQUIRED	3
#DEFINE ADPROMPTNEVER	 4

*---- ConnectModeEnum Values ----
#DEFINE ADMODEUNKNOWN	 0
#DEFINE ADMODEREAD	 1
#DEFINE ADMODEWRITE	 2
#DEFINE ADMODEREADWRITE	 3
#DEFINE ADMODESHAREDENYREAD	 4
#DEFINE ADMODESHAREDENYWRITE	8
#DEFINE ADMODESHAREEXCLUSIVE	0xC
#DEFINE ADMODESHAREDENYNONE	 0x10

*---- IsolationLevelEnum Values ----
#DEFINE ADXACTUNSPECIFIED	 0xFFFFFFFF
#DEFINE ADXACTCHAOS	 0x00000010
#DEFINE ADXACTREADUNCOMMITTED	0x00000100
#DEFINE ADXACTBROWSE	 0x00000100
#DEFINE ADXACTCURSORSTABILITY	0x00001000
#DEFINE ADXACTREADCOMMITTED	 0x00001000
#DEFINE ADXACTREPEATABLEREAD	0x00010000
#DEFINE ADXACTSERIALIZABLE	 0x00100000
#DEFINE ADXACTISOLATED	 0x00100000

*---- XactAttributeEnum Values ----
#DEFINE ADXACTCOMMITRETAINING	0x00020000
#DEFINE ADXACTABORTRETAINING	0x00040000

*---- PropertyAttributesEnum Values ----
#DEFINE ADPROPNOTSUPPORTED	 0x0000
#DEFINE ADPROPREQUIRED	 0x0001
#DEFINE ADPROPOPTIONAL	 0x0002
#DEFINE ADPROPREAD	 0x0200
#DEFINE ADPROPWRITE	 0x0400

*---- ErrorValueEnum Values ----
#DEFINE ADERRINVALIDARGUMENT	 0xBB9
#DEFINE ADERRNOCURRENTRECORD	 0xBCD
#DEFINE ADERRILLEGALOPERATION	 0xC93
#DEFINE ADERRINTRANSACTION	 0xCAE
#DEFINE ADERRFEATURENOTAVAILABLE	0xCB3
#DEFINE ADERRITEMNOTFOUND	 0xCC1
#DEFINE ADERROBJECTINCOLLECTION	 0xD27
#DEFINE ADERROBJECTNOTSET	 0xD5C
#DEFINE ADERRDATACONVERSION	 0xD5D
#DEFINE ADERROBJECTCLOSED	 0xE78
#DEFINE ADERROBJECTOPEN	 0xE79
#DEFINE ADERRPROVIDERNOTFOUND	 0xE7A
#DEFINE ADERRBOUNDTOCOMMAND	 0xE7B
#DEFINE ADERRINVALIDPARAMINFO	 0xE7C
#DEFINE ADERRINVALIDCONNECTION	 0xE7D
#DEFINE ADERRNOTREENTRANT	 0xE7E
#DEFINE ADERRSTILLEXECUTING	 0xE7F
#DEFINE ADERROPERATIONCANCELLED	 0xE80
#DEFINE ADERRSTILLCONNECTING	 0xE81
#DEFINE ADERRINVALIDTRANSACTION	 0xE82

*---- ParameterAttributesEnum Values ----
#DEFINE ADPARAMSIGNED	 0x0010
#DEFINE ADPARAMNULLABLE	 0x0040
#DEFINE ADPARAMLONG	 0x0080

*---- ParameterDirectionEnum Values ----
#DEFINE ADPARAMUNKNOWN	 0x0000
#DEFINE ADPARAMINPUT	 0x0001
#DEFINE ADPARAMOUTPUT	 0x0002
#DEFINE ADPARAMINPUTOUTPUT	0x0003
#DEFINE ADPARAMRETURNVALUE	0x0004

*---- CommandTypeEnum Values ----
#DEFINE ADCMDUNKNOWN	 0x0008
#DEFINE ADCMDTEXT	 0x0001
#DEFINE ADCMDTABLE	 0x0002
#DEFINE ADCMDSTOREDPROC	 0x0004
#DEFINE ADCMDFILE	 0x0020

*---- EventStatusEnum Values ----
#DEFINE ADSTATUSOK	 0x0000001
#DEFINE ADSTATUSERRORSOCCURRED	0x0000002
#DEFINE ADSTATUSCANTDENY	 0x0000003
#DEFINE ADSTATUSCANCEL	 0x0000004
#DEFINE ADSTATUSUNWANTEDEVENT	0x0000005

*---- EventReasonEnum Values ----
#DEFINE ADRSNADDNEW	 1
#DEFINE ADRSNDELETE	 2
#DEFINE ADRSNUPDATE	 3
#DEFINE ADRSNUNDOUPDATE	 4
#DEFINE ADRSNUNDOADDNEW	 5
#DEFINE ADRSNUNDODELETE	 6
#DEFINE ADRSNREQUERY	 7
#DEFINE ADRSNRESYNCH	 8
#DEFINE ADRSNCLOSE	 9
#DEFINE ADRSNMOVE	 10
#DEFINE ADRSNFIRSTCHANGE	11
#DEFINE ADRSNMOVEFIRST	 12
#DEFINE ADRSNMOVENEXT	 13
#DEFINE ADRSNMOVEPREVIOUS	14
#DEFINE ADRSNMOVELAST	 15

*---- SchemaEnum Values ----
#DEFINE ADSCHEMAPROVIDERSPECIFIC	 -1
#DEFINE ADSCHEMAASSERTS	 0
#DEFINE ADSCHEMACATALOGS	 1
#DEFINE ADSCHEMACHARACTERSETS	 2
#DEFINE ADSCHEMACOLLATIONS	 3
#DEFINE ADSCHEMACOLUMNS	 4
#DEFINE ADSCHEMACHECKCONSTRAINTS	 5
#DEFINE ADSCHEMACONSTRAINTCOLUMNUSAGE	6
#DEFINE ADSCHEMACONSTRAINTTABLEUSAGE	7
#DEFINE ADSCHEMAKEYCOLUMNUSAGE	 8
#DEFINE ADSCHEMAREFERENTIALCONTRAINTS	9
#DEFINE ADSCHEMATABLECONSTRAINTS	 10
#DEFINE ADSCHEMACOLUMNSDOMAINUSAGE	 11
#DEFINE ADSCHEMAINDEXES	 12
#DEFINE ADSCHEMACOLUMNPRIVILEGES	 13
#DEFINE ADSCHEMATABLEPRIVILEGES	 14
#DEFINE ADSCHEMAUSAGEPRIVILEGES	 15
#DEFINE ADSCHEMAPROCEDURES	 16
#DEFINE ADSCHEMASCHEMATA	 17
#DEFINE ADSCHEMASQLLANGUAGES	 18
#DEFINE ADSCHEMASTATISTICS	 19
#DEFINE ADSCHEMATABLES	 20
#DEFINE ADSCHEMATRANSLATIONS	 21
#DEFINE ADSCHEMAPROVIDERTYPES	 22
#DEFINE ADSCHEMAVIEWS	 23
#DEFINE ADSCHEMAVIEWCOLUMNUSAGE	 24
#DEFINE ADSCHEMAVIEWTABLEUSAGE	 25
#DEFINE ADSCHEMAPROCEDUREPARAMETERS	 26
#DEFINE ADSCHEMAFOREIGNKEYS	 27
#DEFINE ADSCHEMAPRIMARYKEYS	 28
#DEFINE ADSCHEMAPROCEDURECOLUMNS	 29
#DEFINE ADSCHEMADBINFOKEYWORDS	 30
#DEFINE ADSCHEMADBINFOLITERALS	 31
/*************************** 
*Definicion de tipos de datos 
****************************/

#DEFINE adEmpty 			0
#DEFINE adSmallInt 			2
#DEFINE adInteger 			3
#DEFINE adSingle 			4
#DEFINE adDouble 			5
#DEFINE adCurrency 			6
#DEFINE adDate 				7
#DEFINE adBSTR 				8
#DEFINE adlDispatch 		9
#DEFINE adError 			10
#DEFINE adBoolean 			11
#DEFINE adVariant 			12
#DEFINE adlUnknown 			13
#DEFINE adDecimal 			14
#DEFINE adTinyInt 			16
#DEFINE adUnsignedTyniInt 	17
#DEFINE adUnsignedSmallInt 	18
#DEFINE adUnsignedInt 		19
#DEFINE adBigInt 			20
#DEFINE adUnsignedBigInt 	21
#DEFINE adFileTime 			64
#DEFINE adGUID 				72
#DEFINE adBinary 			128
#DEFINE adChar 				129
#DEFINE adWChar 			130
#DEFINE adNumeric 			131
#DEFINE adUserDefined 		132
#DEFINE adDBDate 			133
#DEFINE adDBTime 			134
#DEFINE adDBTimeStamp 		135
#DEFINE adChapter 			136
#DEFINE adPropVariant 		138
#DEFINE adVarNumeric 		139
#DEFINE adVarChar 			200
#DEFINE adLongVarChar 		201
#DEFINE adVarWChar 			202
#DEFINE adLongVarWChar 		203
#DEFINE adLongVarBinary 	205
#DEFINE adVarBinary 		204
#DEFINE adArray 			8192

/*******
BookMark 
********/
#DEFINE adBookmarkCurrent 	0
#DEFINE adBookmarkFirst 	1
#DEFINE adBookmarkLast 		2

/**********
Valor error
***********/

#define adErrBoundToCommand 3707
#define adErrCannotComplete 3732
#define adErrCantChangeConnection 3748
#define adErrCantChangeProvider 3220
#define adErrCantConvertvalue 3724
#define adErrCantCreate 3725
#define adErrCatalogNotSet 3747
#define adErrColumnNotOnThisRow 3726
#define adErrConnectionStringTooLong 3754
#define adErrDataConversion 3421
#define adErrDataOverflow 3721
#define adErrDelResOutOfScope 3738
#define adErrDenyNotSupported 3750
#define adErrDenyTypeNotSupported 3751
#define adErrFeatureNotAvailable 3251
#define adErrFieldsUpdateFailed 3749
#define adErrIllegalOperation 3219
#define adErrIntegrityViolation 3719
#define adErrinTransaction 3246
#define adErrInvalidArgument 3001
#define adErrInvalidConnection 3709
#define adErrInvalidParamInfo 3708
#define adEddinvalidTransaction 3714
#define adErrinvalidURL 3729
#define adErritemNotFound 3265
#define adErrNoCurrentRecord 3021
#define adErrNotReentrat 3710
#define adErrObjectClosed 3704
#define adErrObjectInCollection 3367
#define adErrObjectNotSet 3420
#define adErrObjectOpen 3705
#define adErrOpeningFile 3002
#define adErrOperationCancelled 3712
#define adErrOutOfSpace 3734
#define adErrPermissionDenied 3720
#define adErrPropConflicting 3742
#define adErrPropInvalidColumn 3739
#define adErrPropInvalidOption 3740
#define adErrPropInvalidValue 3741
#define adErrPropNotAllSettable 3743
#define adErrPropNotSet 3744
#define adErrPropNotSettable 3745
#define adErrPropNotSupported 3746
#define adErrProviderFailed 3000
#define adErrProviderNotFound 3706
#define adErrProviderNotSpecified 3753
#define adErrReadFile 3003
#define adErrResourceExists 3731
#define adErrResourceLocked 3730
#define adErrResourceOutOfScope 3735
#define adErrSchemaViolation 3722
#define adErrSignMismatch 3723
#define adErrStillConnecting 3713
#define adErrStillExecuting 3711
#define adErrTreePermissionDenied 3728
#define adErrUnavailable 3736
#define adErrUnsafeOperation 3716
#define adErrURLDoesNotExist 3727
#define adErrURLNamedRowDoesNotExist 3737
#define adErrVolumeNotFound 3733
#define adErrWriteFile 3004
#define adwrnSecurityDialog 3717
#define adwrnSecurityDialogHeader 3718

/*********************************
OTROS FUNCIONES Y COMANDOS DE ADO.
**********************************

Objeto error del objeto Conexion
Objeto Error
	-Errors -> Coleccion del objeto error
	-Description ->descripcion del error
	-Number -> id/numero del error
	-SQLState -> codigo de error sql
	-Clear	-> elimina los datos del objeto error
	MiConn:Open()
	if MiConn.Errors.Count
		for each error in MiConn:errors
			? Error.Number+" = "+Error.Description
		next
	end
	
	

Metodos de navegacion
----------------------
Rs:Move( n | -n ) Avanza/retrocede el puntero n veces 
Rs:MoveFirst 
Rs:MoveNext
Rs:MoveLast
Rs:MovePrevious

Propiedades del recordset
-------------------------
AbsolutePosition  Setget indica/asigna la posicion del puntero del recordset
Rs:Bof
Rs:Eof
Rs:RecordCount numero de registros que contiene el Rs.

Metodos
Rs:AddNew()	
	crea un nuevo registro
	Rs:AddNew()
		rs("nombre") = "luis"
		rs("edad") = 39
	Rs:Update()
	
	-Modificar un registro
	Rs:("nombre") = "Juan"
	Rs:Update()
	
Rs:CanceUpdate() 
	Cancela el proceso de actualizacion

Rs:Clone() 
	crea una copia del recordset 
	Rs2 := Rs:Clone()

Rs:Close()
	cierra el objeto recordset
Rs:Delete()
	elimina el registro actual del recordset

Rs:GetRows()
	Crea un arreglo con el contenido del recordset

Rs:NextRecordSet()
	Se carga el recordset siguiente en el caso de paginacion

Rs:Requery()
	Se actualiza el recordset refrescando los cambios que hubo en la tabla

Rs:Supports()
	valida si el rs abierto soporta algun metodo o funcion en particular.
Rs:Update()
	actualiza la tabla a la que hace referencia el objeto recordset haciendo
	efectivos los cambios
Rs:AbsolutePage
	Cuando se haya paginado el recordset con esta propiedad se puede 
	determinar la pagina.
Rs:ActiveConnection()
	Sirve para leer el DSN o la ruta correspondiente a la conexion
	relacionada con el rs.
Rs:Bookmark
	devuelve o fija un identificador para el registro actual.
Rs:CacheSize
	Define el numero de registros o filas que el recordset va a
	pre-almacenar en la memoria cache
Rs:EditMode
	seala el estado de edicion de un registro. Existen 3 posibilidades
	- adEditNone : registro no se encuentra editado
	- adEditInProgress : registro en edicion pero no se ha grabado
	- adEditAdd : se ha llamado al metodo AddNew
Rs:Filter
	permite filtrar un recordset manteniendo solo los registros
	que  superen ese filtro
	cFiltro = "Fecha="+dtoc( date() )
	rs:Filter := cfiltro
Rs:MaxRecords
	Permite fijar el numero maximo de registros que aceptara el Rs.
	El valor por defecto es 0 e indica que no existir limite
Rs:PageCount
	Indica cuantas paginas tenemos en funcion del tamao de cada pagina
	que hemos definido con PageSize
Rs:PageSize
	define el numero de registros o filas que forman una pagina
	por defecto son 10.
Rs:State
	seala el estado del rs. Existen 2 posibilidades
	- adStateClose : el rs esta cerrado
	- adStateOpen : el rs esta abierto

Colecciones

Rs:Fields : 
	representa un campo del registro actual y se puede acceder por
	su indice o su nombre
	? Rs:Fields(1)  // devuelve el valor del campo 1
	? Rs:Fields('rut') // devuelve el valor del campo rut

Rs:Properties( xPropiedad )
	permite acceder a las propiedades del rs ya sea las que vienen por
	defecto o las que hayamos modificado.

*/


